
function request(method, url, data, ok, err) {
    let promise = null;
    if(method === "GET") {
        promise = fetch(url);
    } else if(method === "DELETE") {
        promise = fetch(url, {method: method});
    } else {
        promise = fetch(url, {
            method: method,
            body: JSON.stringify(data),
            headers:  {
                'content-type': 'application/json'
            }
        })
    }
    
    promise.then(response => {
        if(response.ok) {
            return response.json();
        } else {
            response.text().then(txt => {
                throw txt;
            }).catch(e => {
                err(e);
            });
            return null;
        }
    }).then(j => {
        if(j) {
            ok(j);
        }
    }).catch(e => {
        err(e);
    });
}

export {request};